{hint: Pascal files location: ...\reaction_time_measurement\jni }
unit reaction_time_measurement_unit;

{$mode delphi}

interface

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, AndroidWidget, stablayout, drawingview, Laz_And_Controls,
  intentmanager, chronometer, preferences, stringtable, FPimage, FPReadPNG,
  Graphics, Math;
  
type

  { TAndroidModule1 }

  TAndroidModule1 = class(jForm)
    ResetSettingsButton: jButton;
    SaveSettingsButton: jButton;
    DataStringGridWebView: jWebView;
    ClearDataTableButton: jButton;
    CopyDataToClipboardButton: jButton;
    fromTextView: jTextView;
    DelayForStimulusShowupStartEdit: jEditText;
    DelayForStimulusShowupEndEdit: jEditText;
    AutoViewDataTableCheckBox: jCheckBox;
    CircleCanvas: jCanvas;
    FixationPointCanvas: jCanvas;
    CircleImage: jImageView;
    FixationPointImage: jImageView;
    ClipboadEditText: jEditText;
    CenterButtonImageView: jImageView;
    ColorPickCanvas: jCanvas;
    ColorPick_jImageView: jImageView;
    jTimer1: jTimer;
    stop_watch_visual: jChronometer;
    stop_watch_2nd_button: jChronometer;
    LeftButtonRoundImage: jImageView;
    RightButtonRoundImage: jImageView;
    VirtualMouseButtonRoundCanvas: jCanvas;
    IncreasedVirtualMouseButtonRoundCanvas: jCanvas;
    stop_watch_delay_stimulus: jChronometer;
    jPreferences1: jPreferences;
    jBitmap_ColorPick: jBitmap;
    jIntentManager1: jIntentManager;
    RateAppButton: jButton;
    MoreAppsButton: jButton;
    ColorPick_Current_jPanel: jPanel;
    AboutWebView: jWebView;
    StimulusColorLabel: jTextView;
    ShowFixationPointCheckBox: jCheckBox;
    ShowInstructionsCheckBox: jCheckBox;
    NumberOfMeasurementsEdit: jEditText;
    NumberOfMeasurementsTextView: jTextView;
    toTextView: jTextView;
    msTextView2: jTextView;
    msTextView1: jTextView;
    RandomDelayTimeTextView: jTextView;
    jPanel1: jPanel;
    jsTabLayout1: jsTabLayout;
    InstructionsLabel: jTextView;
    procedure AndroidModule1Close(Sender: TObject);
    procedure AndroidModule1Create(Sender: TObject);
    procedure AndroidModule1JNIPrompt(Sender: TObject);
    procedure ClearDataTableButtonClick(Sender: TObject);
    procedure CopyDataToClipboardButtonClick(Sender: TObject);
    procedure DelayForStimulusShowupEndEditEnter(Sender: TObject);
    procedure DelayForStimulusShowupEndEditFocus(Sender: TObject;
      textContent: string);
    procedure DelayForStimulusShowupEndEditLostFocus(Sender: TObject;
      textContent: string);
    procedure DelayForStimulusShowupStartEditEnter(Sender: TObject);
    procedure DelayForStimulusShowupStartEditFocus(Sender: TObject;
      textContent: string);
    procedure DelayForStimulusShowupStartEditLostFocus(Sender: TObject;
      textContent: string);
    procedure ColorPick_jImageViewTouchDown(Sender: TObject; Touch: TMouch);
    procedure jsTabLayout1TabSelected(Sender: TObject; position: integer;
      title: string);
    procedure jTimer1Timer(Sender: TObject);
    procedure LeftButtonRoundImageTouchDown(Sender: TObject; Touch: TMouch);
    procedure LeftButtonRoundImageTouchUp(Sender: TObject; Touch: TMouch);
    procedure MoreAppsButtonClick(Sender: TObject);
    procedure NumberOfMeasurementsEditEnter(Sender: TObject);
    procedure NumberOfMeasurementsEditFocus(Sender: TObject; textContent: string
      );
    procedure NumberOfMeasurementsEditLostFocus(Sender: TObject;
      textContent: string);
    procedure RateAppButtonClick(Sender: TObject);
    procedure ResetSettingsButtonClick(Sender: TObject);
    procedure RightButtonRoundImageTouchDown(Sender: TObject; Touch: TMouch);
    procedure RightButtonRoundImageTouchUp(Sender: TObject; Touch: TMouch);
    procedure SaveSettingsButtonClick(Sender: TObject);
    procedure ShowFixationPointCheckBoxClick(Sender: TObject);
    procedure ShowInstructionsCheckBoxClick(Sender: TObject);
  private
    {private declarations}
    function ARGBtoCustomColor(conv_clr: TColorRGBA): DWORD;
    procedure CheckSettings();
    procedure SaveSettings();

  public
    {public declarations}
  end;

var
  AndroidModule1: TAndroidModule1;

  screen_density_rescale: Double;
  circle_image_width, circle_image_height, fixation_point_image_width, fixation_point_image_height: Integer;
  button_x_offset: Integer;
  j_drawing_view_color_pick_width, j_drawing_view_color_pick_width_default: Integer;

  color_picker_width, color_picker_height: Integer;

//  Img: TFPCustomImage;
//  Reader: TFPCustomImageReader;
  init_images: boolean;

  about_html_stringlist: TStringList;
  data_string_grid_html_stringlist: TStringList;
  data_has_changed: Boolean;


  first_button_clicked, second_button_clicked, stimulus_shown: boolean;
  delay_for_stimulus_showup_start, delay_for_stimulus_showup_start_saved, delay_for_stimulus_showup_end, delay_for_stimulus_showup_end_saved: Integer;
  delay_for_stimulus_showup: Integer;
  stop_watch_visual_elapsed_in_ms, stop_watch_2nd_button_elapsed_in_ms: Double;


  step_data_point: Integer;
  number_of_measurements, number_of_measurements_saved: Integer;

  number_of_measurements_default, delay_for_stimulus_showup_start_default, delay_for_stimulus_showup_end_default: Integer;



  device_type: Integer;
  screen_scale: Double;
  main_form_width, main_form_height: Integer;
  fix_main_form_height, fix_main_form_width: Double;
  screen_orientation_int: Integer;
  old_screen_orientation_int: Integer;


  ini_int_result: Integer;
  ini_bool_result: boolean;
  ini_string_result: String;

  button_increase_ratio: Double;
  left_button_rectangle_center_x, right_button_rectangle_center_x: Integer;
  left_button_rectangle_center_y, right_button_rectangle_center_y: Integer;

  left_button_rectangle_position_x, right_button_rectangle_position_x: Integer;
  left_button_rectangle_position_y, right_button_rectangle_position_y: Integer;

  button_width, button_height: Integer;
  increased_button_width, increased_button_height: Integer;



  DataStringGrid: TStringTable;
  instructions_label_visible, fixation_point_image_visible: Boolean;


  selected_tfpcolor_color: TFPColor;
  selected_tcolor_color: TColor;
  selected_RGBA_color: TColorRGBA;
  selected_tcolor_color_string: String;

  touched_pixel: TPoint;
  inverted_RGBA_color: TColorRGBA;


  image_array_of_jbyte: TDynArrayOfJByte; // TDynArrayOfJByte = array of JByte;  //array of shortint
  colorpick_image_width, colorpick_image_height, n, n4: Integer;
  size_image_array_of_jbyte: Integer;
  colorpick_image_scale: Double;


  app_store: Integer;

const GOOGLE_STORE = 1;
const SAMSUNG_STORE = 2;
const HUAWEI_STORE = 3;
const AMAZON_STORE = 4;


//const
//  _color_pick_fn: string = 'color_pick_copy.png';


implementation
  
{$R *.lfm}
  

{ TAndroidModule1 }



procedure TAndroidModule1.CheckSettings();
begin

if(Length(NumberOfMeasurementsEdit.Text) = 0) then
begin
      number_of_measurements := number_of_measurements_saved;
      NumberOfMeasurementsEdit.Text := IntToStr(number_of_measurements);

      DataStringGrid.Free();
      DataStringGrid := TStringTable.Create(3, number_of_measurements + 2);
      step_data_point := 1;

      DataStringGrid.Cells[0, 0] := 'Number';
      DataStringGrid.Cells[1, 0] := 'Stimulus';
      DataStringGrid.Cells[2, 0] := '2nd button';
end;

if(Length(DelayForStimulusShowupEndEdit.Text) = 0) then
begin
     delay_for_stimulus_showup_end := delay_for_stimulus_showup_end_saved;
     DelayForStimulusShowupEndEdit.Text := IntToStr(delay_for_stimulus_showup_end);
end;

if(Length(DelayForStimulusShowupStartEdit.Text) = 0) then
begin
    delay_for_stimulus_showup_start := delay_for_stimulus_showup_start_saved;
    DelayForStimulusShowupStartEdit.Text := IntToStr(delay_for_stimulus_showup_start);
end;


end;


function TAndroidModule1.ARGBtoCustomColor(conv_clr: TColorRGBA): DWORD;
begin
  Result := (conv_clr.A shl 24) + (conv_clr.R shl 16) + (conv_clr.G shl 8) + conv_clr.B;
end;


procedure TAndroidModule1.jsTabLayout1TabSelected(Sender: TObject;
  position: integer; title: string);
var
  i: Integer;
begin

  if position = 0 then
  begin
   jPanel1.BackgroundColor := colbrBlack;
   InstructionsLabel.Visible := instructions_label_visible;
   LeftButtonRoundImage.Visible := true;
   RightButtonRoundImage.Visible := true;
   CircleImage.Visible := false;
   FixationPointImage.Visible := fixation_point_image_visible;

   ClearDataTableButton.Visible := false;
   CopyDataToClipboardButton.Visible := false;
   DataStringGridWebView.Visible := false;

   SaveSettingsButton.Visible := false;
   ResetSettingsButton.Visible := false;
   RandomDelayTimeTextView.Visible := false;
   fromTextView.Visible := false;
   DelayForStimulusShowupStartEdit.Visible := false;
   msTextView1.Visible := false;
   DelayForStimulusShowupEndEdit.Visible := false;
   msTextView2.Visible := false;
   toTextView.Visible := false;
   NumberOfMeasurementsTextView.Visible := false;
   NumberOfMeasurementsEdit.Visible := false;
   AutoViewDataTableCheckBox.Visible := false;
   ShowInstructionsCheckBox.Visible := false;
   ShowFixationPointCheckBox.Visible := false;
   StimulusColorLabel.Visible := false;
   ColorPick_jImageView.Visible := false;
   ColorPick_Current_jPanel.Visible := false;

   MoreAppsButton.Visible := false;
   RateAppButton.Visible := false;
   AboutWebView.Visible := false;


  end
  else if position = 1 then
  begin
   jPanel1.BackgroundColor := colbrWhite;
   InstructionsLabel.Visible := false;
   LeftButtonRoundImage.Visible := false;
   RightButtonRoundImage.Visible := false;
   CircleImage.Visible := false;
   FixationPointImage.Visible := false;

   ClearDataTableButton.Visible := true;
   CopyDataToClipboardButton.Visible := true;
   DataStringGridWebView.Visible := true;

   if (data_has_changed = true) then
   begin
   data_string_grid_html_stringlist.Clear();

   data_string_grid_html_stringlist.Add('<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">');
   data_string_grid_html_stringlist.Add('<html><head><meta content="text/html; charset=ISO-8859-1" http-equiv="content-type"><title>Reaction Time Measurement</title></head>');

   data_string_grid_html_stringlist.Add('<table style="text-align: left; width: 100%;" border="1" cellpadding="2" cellspacing="2">');
   data_string_grid_html_stringlist.Add('<tbody>');
   data_string_grid_html_stringlist.Add('<tr>');
   data_string_grid_html_stringlist.Add('<td style="vertical-align: top;"><b>Number</b></td>');
   data_string_grid_html_stringlist.Add('<td style="vertical-align: top;"><b>Stimulus</b></td>');
   data_string_grid_html_stringlist.Add('<td style="vertical-align: top;"><b>2nd button</b></td>');
   data_string_grid_html_stringlist.Add('</tr>');


   for i := 1 to step_data_point - 1 do
   begin
     data_string_grid_html_stringlist.Add('<tr>');
//     data_string_grid_html_stringlist.Add('<td style="vertical-align: top;">' + IntToStr(i) + '</td>');
     data_string_grid_html_stringlist.Add('<td style="vertical-align: top;">' + DataStringGrid.Cells[0, i] + '</td>');
     data_string_grid_html_stringlist.Add('<td style="vertical-align: top;">' + DataStringGrid.Cells[1, i] + '</td>');
     data_string_grid_html_stringlist.Add('<td style="vertical-align: top;">' + DataStringGrid.Cells[2, i] + '</td>');
     data_string_grid_html_stringlist.Add('</tr>');
   end;

   data_string_grid_html_stringlist.Add('</tbody>');
   data_string_grid_html_stringlist.Add('</table>');
   data_string_grid_html_stringlist.Add('</body></html>');

   DataStringGridWebView.LoadFromHtmlString(data_string_grid_html_stringlist.Text);
   data_has_changed := false;

   end; //if (data_has_changed = true) then


   SaveSettingsButton.Visible := false;
   ResetSettingsButton.Visible := false;
   RandomDelayTimeTextView.Visible := false;
   fromTextView.Visible := false;
   DelayForStimulusShowupStartEdit.Visible := false;
   msTextView1.Visible := false;
   DelayForStimulusShowupEndEdit.Visible := false;
   msTextView2.Visible := false;
   toTextView.Visible := false;
   NumberOfMeasurementsTextView.Visible := false;
   NumberOfMeasurementsEdit.Visible := false;
   AutoViewDataTableCheckBox.Visible := false;
   ShowInstructionsCheckBox.Visible := false;
   ShowFixationPointCheckBox.Visible := false;
   StimulusColorLabel.Visible := false;
   ColorPick_jImageView.Visible := false;
   ColorPick_Current_jPanel.Visible := false;

   MoreAppsButton.Visible := false;
   RateAppButton.Visible := false;
   AboutWebView.Visible := false;


  end
  else if position = 2 then
  begin
    jPanel1.BackgroundColor := colbrWhite;
    InstructionsLabel.Visible := false;
    LeftButtonRoundImage.Visible := false;
    RightButtonRoundImage.Visible := false;
    CircleImage.Visible := false;
    FixationPointImage.Visible := false;

    ClearDataTableButton.Visible := false;
    CopyDataToClipboardButton.Visible := false;
    DataStringGridWebView.Visible := false;


    number_of_measurements_saved := number_of_measurements;
    delay_for_stimulus_showup_start_saved := delay_for_stimulus_showup_start;
    delay_for_stimulus_showup_end_saved := delay_for_stimulus_showup_end;

    NumberOfMeasurementsEdit.Text := IntToStr(number_of_measurements);
    DelayForStimulusShowupStartEdit.Text := IntToStr(delay_for_stimulus_showup_start);
    DelayForStimulusShowupEndEdit.Text := IntToStr(delay_for_stimulus_showup_end);


    SaveSettingsButton.Visible := true;
    ResetSettingsButton.Visible := true;
    RandomDelayTimeTextView.Visible := true;
    fromTextView.Visible := true;
    DelayForStimulusShowupStartEdit.Visible := true;
    msTextView1.Visible := true;
    DelayForStimulusShowupEndEdit.Visible := true;
    msTextView2.Visible := true;
    toTextView.Visible := true;
    NumberOfMeasurementsTextView.Visible := true;
    NumberOfMeasurementsEdit.Visible := true;
    AutoViewDataTableCheckBox.Visible := true;
    ShowInstructionsCheckBox.Visible := true;
    ShowFixationPointCheckBox.Visible := true;
    StimulusColorLabel.Visible := true;

    ColorPick_jImageView.Visible := true;
    ColorPick_Current_jPanel.Visible := true;


    MoreAppsButton.Visible := false;
    RateAppButton.Visible := false;
    AboutWebView.Visible := false;


  end
  else if position = 3 then
  begin
    jPanel1.BackgroundColor := colbrWhite;
    InstructionsLabel.Visible := false;
    LeftButtonRoundImage.Visible := false;
    RightButtonRoundImage.Visible := false;
    CircleImage.Visible := false;
    FixationPointImage.Visible := false;

    ClearDataTableButton.Visible := false;
    CopyDataToClipboardButton.Visible := false;
    DataStringGridWebView.Visible := false;


    SaveSettingsButton.Visible := false;
    ResetSettingsButton.Visible := false;
    RandomDelayTimeTextView.Visible := false;
    fromTextView.Visible := false;
    DelayForStimulusShowupStartEdit.Visible := false;
    msTextView1.Visible := false;
    DelayForStimulusShowupEndEdit.Visible := false;
    msTextView2.Visible := false;
    toTextView.Visible := false;
    NumberOfMeasurementsTextView.Visible := false;
    NumberOfMeasurementsEdit.Visible := false;
    AutoViewDataTableCheckBox.Visible := false;
    ShowInstructionsCheckBox.Visible := false;
    ShowFixationPointCheckBox.Visible := false;
    StimulusColorLabel.Visible := false;
    ColorPick_jImageView.Visible := false;
    ColorPick_Current_jPanel.Visible := false;

    MoreAppsButton.Visible := true;
    RateAppButton.Visible := true;
    AboutWebView.Visible := true;


  end;

end;

procedure TAndroidModule1.jTimer1Timer(Sender: TObject);
begin



    if(first_button_clicked = true) then
    begin


    if(stimulus_shown = false) then
    begin



    stop_watch_delay_stimulus.Stop();


    if (delay_for_stimulus_showup < stop_watch_delay_stimulus.GetElapsedTimeMillis()) then
    begin

    delay_for_stimulus_showup := 0;
    stimulus_shown := true;

    stop_watch_delay_stimulus.Reset();

    CircleImage.Visible := true;

    stop_watch_visual.Reset();
    stop_watch_visual.Start();


    end;//if (delay_for_stimulus_showup < stop_watch_delay_stimulus.GetElapsedTimeMillis())


    stop_watch_delay_stimulus.Start();

    end//if(stimulus_shown = false)


    end//if(first_button_clicked = true)


end;

procedure TAndroidModule1.LeftButtonRoundImageTouchDown(Sender: TObject;
  Touch: TMouch);
begin


    if(jTimer1.Enabled = true) then
    begin

        Randomize();
        delay_for_stimulus_showup := delay_for_stimulus_showup_start + Random(delay_for_stimulus_showup_end - delay_for_stimulus_showup_start);


        {$IFDEF ANDROID}
        InstructionsLabel.Text := 'Keep left button pressed until circle shows up.' + LineEnding + 'Then release left button and press right button as quickly as you can.';
        {$ELSE}
        InstructionsLabel.Text := 'Keep left mouse button pressed' + LineEnding + 'until circle shows up.' + LineEnding + 'Then release left mouse button and press right' + LineEnding + 'mouse button as quickly as you can.';
        {$ENDIF}


        stop_watch_2nd_button.Stop();
        stop_watch_2nd_button.Reset();

        stop_watch_delay_stimulus.Stop();
        stop_watch_delay_stimulus.Reset();
        stop_watch_delay_stimulus.Start();

        first_button_clicked := true;
        stimulus_shown := false;

        second_button_clicked := false;

    end;//if(jTimer1.Enabled = true)

    LeftButtonRoundImage.SetImageBitmap(IncreasedVirtualMouseButtonRoundCanvas.GetBitmap());

end;

procedure TAndroidModule1.LeftButtonRoundImageTouchUp(Sender: TObject;
  Touch: TMouch);
begin



    if(jTimer1.Enabled = true) then
    begin

    if((stimulus_shown = false) and (first_button_clicked = true)) then
    begin

     first_button_clicked := false;

     stop_watch_2nd_button.Stop();
     stop_watch_2nd_button.Reset();

     stop_watch_delay_stimulus.Stop();
     stop_watch_delay_stimulus.Reset();

     {$IFDEF ANDROID}
     InstructionsLabel.Text := 'Visual stimulus has not shown up yet when you have released button.' + LineEnding + 'Press left button to repeat.';
     {$ELSE}
     InstructionsLabel.Text := 'Visual stimulus has not shown up yet' + LineEnding + 'when you have released mouse button.' + LineEnding + 'Press left mouse button to repeat.';
     {$ENDIF}


    end
    else //if((stimulus_shown = true) and (first_button_clicked = false) and (second_button_clicked = true)) then
    begin

     first_button_clicked := false;
     stimulus_shown := false;


     stop_watch_visual.Stop();

     stop_watch_2nd_button.Reset();
     stop_watch_2nd_button.Start();

    stop_watch_visual_elapsed_in_ms := stop_watch_visual.GetElapsedTimeMillis();

    end;//else if(stimulus_shown = false)


    CircleImage.Visible := false;


    end;//if(jTimer1.Enabled = true)

    LeftButtonRoundImage.SetImageBitmap(VirtualMouseButtonRoundCanvas.GetBitmap());

end;

procedure TAndroidModule1.MoreAppsButtonClick(Sender: TObject);
begin


  //jIntentManager1.SetAction(iaView);  //or 'android.intent.action.VIEW' // <<--- important to set

  if(app_store = GOOGLE_STORE) then
  begin
  //jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://search?q=pname:'+'com.google.android.camera')); //works
  //jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://dev?id=5448858571649033555')); // fails to work
  //jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://developer?id=Cognaxon')); // fails to work
  jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://play.google.com/store/apps/developer?id=Cognaxon')); //works
  end
  else if(app_store = SAMSUNG_STORE) then
  begin
  jIntentManager1.SetDataUri(jIntentManager1.ParseUri('http://cognaxon.com/index.php?page=download_educational'));
  end
  else if(app_store = HUAWEI_STORE) then
  begin
  jIntentManager1.SetDataUri(jIntentManager1.ParseUri('http://cognaxon.com/index.php?page=download_educational'));
  end
  else if(app_store = AMAZON_STORE) then
  begin
  jIntentManager1.SetDataUri(jIntentManager1.ParseUri('http://www.amazon.com/gp/mas/dl/android?s=Cognaxon')); //works
  end
  else
  begin
  jIntentManager1.SetDataUri(jIntentManager1.ParseUri('http://cognaxon.com/index.php?page=download_educational'));
  end;



  jIntentManager1.StartActivity();

end;

procedure TAndroidModule1.NumberOfMeasurementsEditEnter(Sender: TObject);
begin


    number_of_measurements := StrToIntDef(NumberOfMeasurementsEdit.Text, number_of_measurements_default);
    if((number_of_measurements <= 0) or (number_of_measurements > 1000)) then
    begin
      ShowMessage('Please enter value from 1 to 1000');
      number_of_measurements := number_of_measurements_saved;
      NumberOfMeasurementsEdit.Text := IntToStr(number_of_measurements);
      NumberOfMeasurementsEdit.SetFocus();
      NumberOfMeasurementsEdit.SelectAll();
    end;

    DataStringGrid.Free();
    DataStringGrid := TStringTable.Create(3, number_of_measurements + 2);
    step_data_point := 1;

    DataStringGrid.Cells[0, 0] := 'Number';
    DataStringGrid.Cells[1, 0] := 'Stimulus';
    DataStringGrid.Cells[2, 0] := '2nd button';

end;

procedure TAndroidModule1.NumberOfMeasurementsEditFocus(Sender: TObject;
  textContent: string);
begin

    number_of_measurements_saved := number_of_measurements;

end;

procedure TAndroidModule1.NumberOfMeasurementsEditLostFocus(Sender: TObject;
  textContent: string);
begin

    CheckSettings();

end;

procedure TAndroidModule1.RateAppButtonClick(Sender: TObject);
begin



  //jIntentManager1.SetAction(iaView);  //or 'android.intent.action.VIEW' // <<--- important to set

  if(app_store = GOOGLE_STORE) then
  begin
  jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://details?id=com.cognaxon.reaction_time_measurement'));
  //jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://play.google.com/store/apps/details?id=com.cognaxon.reaction_time_measurement'));
  end
  else if(app_store = SAMSUNG_STORE) then
  begin
  jIntentManager1.SetDataUri(jIntentManager1.ParseUri('samsungapps://AppRating/com.cognaxon.reaction_time_measurement'));
  // jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://apps.samsung.com/appquery/AppRating.as?appId=com.cognaxon.reaction_time_measurement'));
  end
  else if(app_store = HUAWEI_STORE) then
  begin
  //jIntentManager1.SetDataUri(jIntentManager1.ParseUri('appmarket://details?id=com.cognaxon.reaction_time_measurement'));
  jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://appgallery.cloud.huawei.com/appDetail?pkgName=com.cognaxon.reaction_time_measurement'));
  end
  else if(app_store = AMAZON_STORE) then
  begin
  //jIntentManager1.SetDataUri(jIntentManager1.ParseUri('amzn://apps/android?p=com.cognaxon.reaction_time_measurement'));
  jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://www.amazon.com/gp/mas/dl/android?p=com.cognaxon.reaction_time_measurement'));
  end
  else
  begin
  jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://play.google.com/store/apps/details?id=com.cognaxon.reaction_time_measurement'));
  end;



  jIntentManager1.StartActivity();


  //jIntentManager1.SetAction(iaView);  //or 'android.intent.action.VIEW'

  {
  try
    try
      //jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://search?q=pname:'+'com.google.android.camera')); //works
      jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://details?id=com.cognaxon.reaction_time_measurement'));
    except
    on E: Exception do
      jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://play.google.com/store/apps/details?id=com.cognaxon.reaction_time_measurement'));
    end;
  finally
    jIntentManager1.StartActivity();
  end;
  }


end;

procedure TAndroidModule1.ResetSettingsButtonClick(Sender: TObject);
begin

  number_of_measurements := number_of_measurements_default;
  NumberOfMeasurementsEdit.Text := IntToStr(number_of_measurements);

  delay_for_stimulus_showup_start := delay_for_stimulus_showup_start_default;
  DelayForStimulusShowupStartEdit.Text := IntToStr(delay_for_stimulus_showup_start);

  delay_for_stimulus_showup_end := delay_for_stimulus_showup_end_default;
  DelayForStimulusShowupEndEdit.Text := IntToStr(delay_for_stimulus_showup_end);


  DataStringGrid.Free();
  DataStringGrid := TStringTable.Create(3, number_of_measurements + 2);
  step_data_point := 1;

  DataStringGrid.Cells[0, 0] := 'Number';
  DataStringGrid.Cells[1, 0] := 'Stimulus';
  DataStringGrid.Cells[2, 0] := '2nd button';


  instructions_label_visible := true;
  InstructionsLabel.Visible := instructions_label_visible;
  ShowInstructionsCheckBox.Checked := instructions_label_visible;

  fixation_point_image_visible := true;
  FixationPointImage.Visible := fixation_point_image_visible;
  ShowFixationPointCheckBox.Checked := fixation_point_image_visible;

  AutoViewDataTableCheckBox.Checked := true;

  selected_tcolor_color := StringToColor('$FFFFFF');
  selected_RGBA_color.A := $FF; // not transparent
  selected_RGBA_color.R := RED(selected_tcolor_color);
  selected_RGBA_color.G := GREEN(selected_tcolor_color);
  selected_RGBA_color.B := BLUE(selected_tcolor_color);


  ColorPick_Current_jPanel.CustomColor := selected_tcolor_color;
  ColorPick_Current_jPanel.BackgroundColor := colbrCustom;

  SaveSettings();
  ShowMessage('Settings reset completed.');

end;

procedure TAndroidModule1.RightButtonRoundImageTouchDown(Sender: TObject;
  Touch: TMouch);
begin



    if(jTimer1.Enabled = true) then
    begin


      if(second_button_clicked = true) then
      begin
        Exit;
      end;

       stop_watch_2nd_button.Stop();
       stop_watch_2nd_button_elapsed_in_ms := stop_watch_2nd_button.GetElapsedTimeMillis();

       DataStringGrid.Cells[0, step_data_point] := IntToStr(step_data_point);
       DataStringGrid.Cells[1, step_data_point] := FloatToStr(stop_watch_visual_elapsed_in_ms);
       DataStringGrid.Cells[2, step_data_point] := FloatToStr(stop_watch_2nd_button_elapsed_in_ms);
       Inc(step_data_point);
       data_has_changed := true;


         if(step_data_point > number_of_measurements) then
         begin
           CircleImage.Visible := false;
    	 InstructionsLabel.Text := 'Reaction time measurements completed.' + LineEnding + 'Use data table to view measured data.';
    	 jTimer1.Enabled := false;
    	   if(AutoViewDataTableCheckBox.Checked = true) then
    	   begin
               jsTabLayout1TabSelected(Self, 1, '');
    	   end; //if(AutoViewDataTableCheckBox.Checked = true)
         end //if(step_data_point >= number_of_measurements)
         else
         begin
    	 InstructionsLabel.Text := 'Reaction times are:' + LineEnding + '' + FloatToStr(stop_watch_visual_elapsed_in_ms) + ' ms (visual stimulus)' + LineEnding + '' + FloatToStr(stop_watch_2nd_button_elapsed_in_ms) + ' ms (second button)' + LineEnding + 'Press left mouse button for next measurement.';

    //     InstructionsLabel.Repaint();
    //     Application.ProcessMessages();


         end;//else if(step_data_point > number_of_measurements) then

      first_button_clicked := false;
      second_button_clicked := true;

    end;//if(jTimer1.Enabled = true)

    RightButtonRoundImage.SetImageBitmap(IncreasedVirtualMouseButtonRoundCanvas.GetBitmap());

end;

procedure TAndroidModule1.RightButtonRoundImageTouchUp(Sender: TObject;
  Touch: TMouch);
begin

  RightButtonRoundImage.SetImageBitmap(VirtualMouseButtonRoundCanvas.GetBitmap());

end;

procedure TAndroidModule1.SaveSettingsButtonClick(Sender: TObject);
begin

  SaveSettings();
  ShowMessage('Settings saved.');
//    ShowMessage('Settings saved: ' + IntToStr(number_of_measurements) + ', ' + IntToStr(delay_for_stimulus_showup_start) + ', ' + IntToStr(delay_for_stimulus_showup_end));

end;


procedure TAndroidModule1.ShowFixationPointCheckBoxClick(Sender: TObject);
begin

  fixation_point_image_visible := ShowFixationPointCheckBox.Checked;

end;

procedure TAndroidModule1.ShowInstructionsCheckBoxClick(Sender: TObject);
begin

  instructions_label_visible := ShowInstructionsCheckBox.Checked;
end;

procedure TAndroidModule1.AndroidModule1JNIPrompt(Sender: TObject);
begin



  //Self.jsTabLayout1.SetBackgroundToPrimaryColor();
  //Self.jsTabLayout1.SetElevation(20);
  Self.jsTabLayout1.SetSelectedTabIndicatorHeight(3);
  Self.jsTabLayout1.SetSelectedTabIndicatorColor(colbrLime);

  Self.jsTabLayout1.AddTab('Experiment');
  Self.jsTabLayout1.AddTab('Data');
  Self.jsTabLayout1.AddTab('Options');
  Self.jsTabLayout1.AddTab('About');




  jBitmap_ColorPick.LoadFromAssets('color_pick.png');
  //ShowMessage(Self.GetEnvironmentDirectoryPath(dirInternalAppStorage));
  //ShowMessage(Self.GetEnvironmentDirectoryPath(dirDownloads));

//----------------------------------
  image_array_of_jbyte := nil;
  jBitmap_ColorPick.BitmapToArrayOfJByte(image_array_of_jbyte); //jBitmap1.BitmapToArrayOfJByte(TDynArrayOfJByte);

  // https://www.freepascal.org/docs-html/rtl/system/length.html
  size_image_array_of_jbyte := Length(image_array_of_jbyte); // Returns length of a string or array.

    if(size_image_array_of_jbyte = 0) then
    begin
      ShowMessage('Error: size of file color_pick.png is 0');
      Exit;
    end;

    colorpick_image_width := jBitmap_ColorPick.Width;
    colorpick_image_height := jBitmap_ColorPick.Height;
//----------------------------------



  about_html_stringlist.Clear();
  about_html_stringlist.Add('<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">');
  about_html_stringlist.Add('<html><head><meta content="text/html; charset=ISO-8859-1" http-equiv="content-type"><title>Reaction Time Measurement</title></head>');

  about_html_stringlist.Add('<body><big><b>Reaction Time Measurement. Version ' + Self.GetVersionName() + ' (build: '+ IntToStr(Self.GetVersionCode()) + ')</b></big><br>');
  about_html_stringlist.Add('<br>');
  about_html_stringlist.Add('A tool for psychophysics laboratory experiments.<br>');
  about_html_stringlist.Add('Measures reaction time between:<br>');
  about_html_stringlist.Add(' 1) appearance of visual stimulus and the release of the first button;<br>');
  about_html_stringlist.Add(' 2) the release of the first button and pressing of the second button.<br>');
  about_html_stringlist.Add('<br>');
  about_html_stringlist.Add('<br>');
  about_html_stringlist.Add('"Reaction Time Measurement" is free open-source cross-platform software made by Cognaxon<br>');
  about_html_stringlist.Add('<a href="http://cognaxon.com">http://cognaxon.com</a><br>');
  about_html_stringlist.Add('<br>');
  about_html_stringlist.Add('Reaction Time Measurement compiled for Android, compilation date: ' + {$include %date%} + ', time: ' + Format('%.*d',[2, {$include %timeHour%}]) + ':' + Format('%.*d',[2, {$include %timeMinute%}]) );
  about_html_stringlist.Add('<br>');
  about_html_stringlist.Add('<br>');
  about_html_stringlist.Add('Please check out official "Neurocluster Brain Model" site which is available at the address:<br>');
  about_html_stringlist.Add('<a href="http://neuroclusterbrain.com">http://neuroclusterbrain.com</a><br>');
  about_html_stringlist.Add('</body></html>');


  AboutWebView.LoadFromHtmlString(about_html_stringlist.Text);

//=======

    number_of_measurements := jPreferences1.GetIntData('number_of_measurements', number_of_measurements_default);

    if((number_of_measurements < 0) or (number_of_measurements > 10000)) then // protection from crash
    begin
    number_of_measurements := number_of_measurements_default;
    end;


    delay_for_stimulus_showup_start := jPreferences1.GetIntData('delay_for_stimulus_showup_start', delay_for_stimulus_showup_start_default);

    if((delay_for_stimulus_showup_start < 0) or (delay_for_stimulus_showup_start > 100000)) then // protection from crash
    begin
    delay_for_stimulus_showup_start := delay_for_stimulus_showup_start_default;
    end;


    delay_for_stimulus_showup_end := jPreferences1.GetIntData('delay_for_stimulus_showup_end', delay_for_stimulus_showup_end_default);

    if((delay_for_stimulus_showup_end < 0) or (delay_for_stimulus_showup_end > 1000000)) then // protection from crash
    begin
    delay_for_stimulus_showup_end := delay_for_stimulus_showup_end_default;
    end;



    instructions_label_visible := jPreferences1.GetBoolData('show_instructions', true);
    InstructionsLabel.Visible := instructions_label_visible;
    ShowInstructionsCheckBox.Checked := instructions_label_visible;

    fixation_point_image_visible := jPreferences1.GetBoolData('show_fixation_point', true);
    FixationPointImage.Visible := fixation_point_image_visible;
    ShowFixationPointCheckBox.Checked := fixation_point_image_visible;


    AutoViewDataTableCheckBox.Checked := jPreferences1.GetBoolData('auto_view_data_table', true);


    selected_tcolor_color := StringToColor(jPreferences1.GetStringData('stimulus_color', '$FFFFFF'));
    selected_RGBA_color.A := $FF; // not transparent
    selected_RGBA_color.R := RED(selected_tcolor_color);
    selected_RGBA_color.G := GREEN(selected_tcolor_color);
    selected_RGBA_color.B := BLUE(selected_tcolor_color);



ColorPick_Current_jPanel.CustomColor := selected_tcolor_color;
ColorPick_Current_jPanel.BackgroundColor := colbrCustom;





DataStringGrid := TStringTable.Create(3, number_of_measurements + 2);
step_data_point := 1;

DataStringGrid.Cells[0, 0] := 'Number';
DataStringGrid.Cells[1, 0] := 'Stimulus';
DataStringGrid.Cells[2, 0] := '2nd button';


//=====================

  screen_density_rescale := (Self.GetScreenDpi() / 160.0);
  //ShowMessage(FloatToStr(screen_density_rescale/2.0));


  button_increase_ratio := 1.3;

  button_width := Floor(198.0*(screen_density_rescale/2.0));
  button_height := Floor(360.0*(screen_density_rescale/2.0));

  increased_button_width := Ceil(button_width * button_increase_ratio);
  increased_button_height := Floor(button_height * button_increase_ratio);



  circle_image_width := Floor(200.0*(screen_density_rescale/2.0));
  circle_image_height := circle_image_width;

  //Initialize canvas..
  CircleCanvas.CreateBitmap(circle_image_width, circle_image_height, colbrNone);
  CircleCanvas.CustomColor := ARGBtoCustomColor(selected_RGBA_color);
  CircleCanvas.PaintColor := colbrCustom; // colbrWhite;
  CircleCanvas.PaintStyle := psFill;
  CircleCanvas.PaintStrokeWidth := 0;
  CircleCanvas.DrawCircle(circle_image_width div 2, circle_image_height div 2, circle_image_width div 2);

  CircleImage.Width := circle_image_width;
  CircleImage.Height := circle_image_height;
  CircleImage.SetImageBitmap(CircleCanvas.GetBitmap());
  CircleImage.Visible := false;


  //Redraw ColorPick_Current_jPanel in touched color
  //ColorPick_Current_jPanel.CustomColor := ARGBtoCustomColor(selected_RGBA_color);
  ColorPick_Current_jPanel.CustomColor := CircleCanvas.CustomColor;
  ColorPick_Current_jPanel.BackgroundColor := colbrCustom;

  fixation_point_image_width := Floor(10.0*(screen_density_rescale/2.0));
  fixation_point_image_height := fixation_point_image_width;

  FixationPointCanvas.CreateBitmap(fixation_point_image_width, fixation_point_image_height, colbrNone);
  FixationPointCanvas.PaintColor := colbrWhite;
  FixationPointCanvas.PaintStyle := psFill;
  FixationPointCanvas.PaintStrokeWidth := 0;
  FixationPointCanvas.DrawCircle(fixation_point_image_width div 2, fixation_point_image_height div 2, fixation_point_image_width div 2);

  FixationPointImage.Width := fixation_point_image_width;
  FixationPointImage.Height := fixation_point_image_height;
  FixationPointImage.SetImageBitmap(FixationPointCanvas.GetBitmap());
  FixationPointImage.BringToFront();
  FixationPointImage.Visible := fixation_point_image_visible;



    button_x_offset := (increased_button_width - button_width) div 2;

    VirtualMouseButtonRoundCanvas.CreateBitmap(increased_button_width, increased_button_height, colbrNone);
    VirtualMouseButtonRoundCanvas.PaintColor := colbrWhite;
    VirtualMouseButtonRoundCanvas.PaintStyle := psFill;
    VirtualMouseButtonRoundCanvas.PaintStrokeWidth := 0;
    VirtualMouseButtonRoundCanvas.DrawCircle(increased_button_width div 2, increased_button_width div 2, button_width div 2);
    VirtualMouseButtonRoundCanvas.DrawCircle(increased_button_width div 2, increased_button_height - increased_button_width div 2, button_width div 2);
    VirtualMouseButtonRoundCanvas.DrawRect(0 + button_x_offset,  increased_button_width div 2, increased_button_width - button_x_offset, increased_button_height - increased_button_width div 2);

    IncreasedVirtualMouseButtonRoundCanvas.CreateBitmap(increased_button_width, increased_button_height, colbrNone);
    IncreasedVirtualMouseButtonRoundCanvas.PaintColor := colbrWhite;
    IncreasedVirtualMouseButtonRoundCanvas.PaintStyle := psFill;
    IncreasedVirtualMouseButtonRoundCanvas.PaintStrokeWidth := 0;
    IncreasedVirtualMouseButtonRoundCanvas.DrawCircle(increased_button_width div 2, increased_button_width div 2, increased_button_width div 2);
    IncreasedVirtualMouseButtonRoundCanvas.DrawCircle(increased_button_width div 2, increased_button_height - increased_button_width div 2, increased_button_width div 2);
    IncreasedVirtualMouseButtonRoundCanvas.DrawRect(0, increased_button_width div 2, increased_button_width, increased_button_height - increased_button_width div 2);

    RightButtonRoundImage.Width := increased_button_width;
    RightButtonRoundImage.Height := increased_button_height;
    RightButtonRoundImage.SetImageBitmap(VirtualMouseButtonRoundCanvas.GetBitmap());
    RightButtonRoundImage.BringToFront();

    LeftButtonRoundImage.Width := increased_button_width;
    LeftButtonRoundImage.Height := increased_button_height;
    LeftButtonRoundImage.SetImageBitmap(VirtualMouseButtonRoundCanvas.GetBitmap());
    LeftButtonRoundImage.BringToFront();
  //=======

  CenterButtonImageView.Width := Floor(40.0*(screen_density_rescale/2.0));


  ColorPick_jImageView.Width := Floor(256.0*(screen_density_rescale/2.0));
  ColorPick_jImageView.Height := Floor(256.0*(screen_density_rescale/2.0));

  colorpick_image_scale := jBitmap_ColorPick.Width / Floor(256.0*(screen_density_rescale/2.0));


  ColorPick_Current_jPanel.Width := Floor(128.0*(screen_density_rescale/2.0));
  ColorPick_Current_jPanel.Height := Floor(128.0*(screen_density_rescale/2.0));


  DelayForStimulusShowupStartEdit.Width := Floor(200.0*(screen_density_rescale/2.0));
  DelayForStimulusShowupEndEdit.Width := Floor(200.0*(screen_density_rescale/2.0));
  NumberOfMeasurementsEdit.Width := Floor(200.0*(screen_density_rescale/2.0));
  //=====================


   color_picker_width := Floor(256.0*(screen_density_rescale/2.0));
   color_picker_height := color_picker_width;
   ColorPickCanvas.CreateBitmap(color_picker_width, color_picker_height, colbrBlack);
   ColorPickCanvas.DrawBitmap(jBitmap_ColorPick.GetImage(), 0, 0, color_picker_width, color_picker_height);
   ColorPick_jImageView.SetImageBitmap(ColorPickCanvas.GetBitmap());



    jTimer1.Enabled := true;


end;


procedure TAndroidModule1.ClearDataTableButtonClick(Sender: TObject);
var
 ai:Integer;
begin

  ClearDataTableButton.Enabled := false;

  jTimer1.Enabled := true;


  {$IFDEF ANDROID}
   InstructionsLabel.Text := 'Press left button.' + LineEnding + 'Keep left button pressed until circle shows up.' + LineEnding + 'Then release left button and press right button as quickly as you can.';
  {$ELSE}
   InstructionsLabel.Text := 'Press left mouse button.' + LineEnding + 'Keep left mouse button pressed' + LineEnding + 'until circle shows up.' + LineEnding + 'Then release left mouse button and press right' + LineEnding + 'mouse button as quickly as you can.';
  {$ENDIF}


  for ai := 0 to DataStringGrid.RowCount-1 do
  begin

   DataStringGrid.Cells[0, ai] := '';
   DataStringGrid.Cells[1, ai] := '';
   DataStringGrid.Cells[2, ai] := '';
  end;

  step_data_point := 1;

  ClearDataTableButton.Enabled := true;

  jsTabLayout1TabSelected(Self, 0, '');

end;

procedure TAndroidModule1.CopyDataToClipboardButtonClick(Sender: TObject);
var
 i: Integer;
begin

   CopyDataToClipboardButton.Enabled := false;

  //ClipboadEditText := jEditText.Create(Self); //does not work, need to add jEditText in Designer
  //ClipboadEditText.Visible := True;
  //ClipboadEditText.InputTypeEx := itxMultiLine;
  ClipboadEditText.MaxLines := step_data_point;
  ClipboadEditText.MaxTextLength := step_data_point * 100;
  //ClipboadEditText.Free;

    for i := 1 to step_data_point - 1 do
    begin
      ClipboadEditText.AppendLn(DataStringGrid.Cells[0, i] + CHR(9) + DataStringGrid.Cells[1, i] + CHR(9) + DataStringGrid.Cells[2, i]);
    end;//for i := 1 to step_data_point - 1 do

    ClipboadEditText.CopyToClipboard();

    CopyDataToClipboardButton.Enabled := true;


end;

procedure TAndroidModule1.DelayForStimulusShowupEndEditEnter(Sender: TObject);
begin

    delay_for_stimulus_showup_end := StrToIntDef(DelayForStimulusShowupEndEdit.Text, delay_for_stimulus_showup_end_default);

    if(delay_for_stimulus_showup_start >= delay_for_stimulus_showup_end) then
    begin
      ShowMessage('''from'' time must be less than ''to'' time');
      delay_for_stimulus_showup_end := delay_for_stimulus_showup_end_saved;
      DelayForStimulusShowupEndEdit.Text := IntToStr(delay_for_stimulus_showup_end);
      DelayForStimulusShowupEndEdit.SetFocus();
      DelayForStimulusShowupEndEdit.SelectAll();
    end
    else if((delay_for_stimulus_showup_end <= 0) or (delay_for_stimulus_showup_end > 1000000)) then
    begin
      ShowMessage('Please enter value from 1 to 1000000');
      delay_for_stimulus_showup_end := delay_for_stimulus_showup_end_saved;
      DelayForStimulusShowupEndEdit.Text := IntToStr(delay_for_stimulus_showup_end);
      DelayForStimulusShowupEndEdit.SetFocus();
      DelayForStimulusShowupEndEdit.SelectAll();
    end;

end;

procedure TAndroidModule1.DelayForStimulusShowupEndEditFocus(Sender: TObject;
  textContent: string);
begin

    delay_for_stimulus_showup_end_saved := delay_for_stimulus_showup_end;

end;

procedure TAndroidModule1.DelayForStimulusShowupEndEditLostFocus(
  Sender: TObject; textContent: string);
begin

    CheckSettings();

end;

procedure TAndroidModule1.DelayForStimulusShowupStartEditEnter(Sender: TObject);
begin

    delay_for_stimulus_showup_start := StrToIntDef(DelayForStimulusShowupStartEdit.Text, delay_for_stimulus_showup_start_default);

    if(delay_for_stimulus_showup_start >= delay_for_stimulus_showup_end) then
    begin
      ShowMessage('''from'' time must be less than ''to'' time');
      delay_for_stimulus_showup_start := delay_for_stimulus_showup_start_saved;
      DelayForStimulusShowupStartEdit.Text := IntToStr(delay_for_stimulus_showup_start);
      DelayForStimulusShowupStartEdit.SetFocus();
      DelayForStimulusShowupStartEdit.SelectAll();
    end
    else if((delay_for_stimulus_showup_start <= 0) or (delay_for_stimulus_showup_start > 100000)) then
    begin
      ShowMessage('Please enter value from 1 to 100000');
      delay_for_stimulus_showup_start := delay_for_stimulus_showup_start_saved;
      DelayForStimulusShowupStartEdit.Text := IntToStr(delay_for_stimulus_showup_start);
      DelayForStimulusShowupStartEdit.SetFocus();
      DelayForStimulusShowupStartEdit.SelectAll();
    end;


end;

procedure TAndroidModule1.DelayForStimulusShowupStartEditFocus(Sender: TObject;
  textContent: string);
begin

    delay_for_stimulus_showup_start_saved := delay_for_stimulus_showup_start;

end;

procedure TAndroidModule1.DelayForStimulusShowupStartEditLostFocus(
  Sender: TObject; textContent: string);
begin

    CheckSettings();

end;



procedure TAndroidModule1.ColorPick_jImageViewTouchDown(Sender: TObject;
  Touch: TMouch);
begin

{
     if (init_images = false) then
     begin
       init_images := true;
       if (Self.FileExists(Self.GetEnvironmentDirectoryPath(dirInternalAppStorage) + '/' + _color_pick_fn)) then
       begin

       ini_int_result := jPreferences1.GetIntData('color_pick_width', j_drawing_view_color_pick_width_default);
       if((j_drawing_view_color_pick_width) <> ini_int_result) then
       begin
         //needed only if ColorPick_jImageView is resized during execution of program
         //ShowMessage('Delete old resource: ' + _color_pick_fn);
         Self.DeleteFile(Self.GetEnvironmentDirectoryPath(dirInternalAppStorage), _color_pick_fn);
         //ColorPick_jImageView.SaveToFile(Self.GetEnvironmentDirectoryPath(dirInternalAppStorage) + '/' + _color_pick_fn);
         j_drawing_view_color_pick_width := ColorPick_jImageView.Width;
         jPreferences1.SetIntData('color_pick_width', j_drawing_view_color_pick_width);
       end;

       end
       else
       begin
         // ShowMessage('SaveToFile');
         ColorPick_jImageView.SaveToFile(Self.GetEnvironmentDirectoryPath(dirInternalAppStorage) + '/' + _color_pick_fn);
         j_drawing_view_color_pick_width := ColorPick_jImageView.Width;
         jPreferences1.SetIntData('color_pick_width', j_drawing_view_color_pick_width);
       end;

       Img := TFPMemoryImage.Create(ColorPick_jImageView.Width,ColorPick_jImageView.Height);
       Reader := TFPReaderPNG.Create;
       Img.LoadFromFile(Self.GetEnvironmentDirectoryPath(dirInternalAppStorage) + '/' + _color_pick_fn, Reader);

       //ShowMessage('init_images');
     end;


     j_drawing_view_color_pick_width := ColorPick_jImageView.Width;
     jPreferences1.SetIntData('color_pick_width', j_drawing_view_color_pick_width);
}

    touched_pixel := Point(Floor(Touch.Pt.x), Floor(Touch.Pt.y));


    //ShowMessage(FloatToStr(colorpick_image_scale));

    n := colorpick_image_width*Floor(Touch.Pt.y*colorpick_image_scale) + Floor(Touch.Pt.x*colorpick_image_scale);
    n4 := n * 4;

    selected_RGBA_color.A := $FF; // not transparent
    selected_RGBA_color.R := Byte(image_array_of_jbyte[n4 + 0]);
    selected_RGBA_color.G := Byte(image_array_of_jbyte[n4 + 1]);
    selected_RGBA_color.B := Byte(image_array_of_jbyte[n4 + 2]);

    selected_tcolor_color := RGBToColor(selected_RGBA_color.R, selected_RGBA_color.G, selected_RGBA_color.B);



    if (init_images) then
    begin
{
      selected_tfpcolor_color := Img.colors[touched_pixel.X, touched_pixel.Y];//get touched pixel in TFPCOLOR
      selected_tcolor_color := FPColorToTColor(selected_tfpcolor_color);
      // convert color to  TColor (regular FPC color) - to show via
      // convert TColor to  TColorRGBA (used on LAMW:Android)
      selected_RGBA_color.A := $FF; // not transparent
      selected_RGBA_color.R := RED(selected_tcolor_color);
      selected_RGBA_color.G := GREEN(selected_tcolor_color);
      selected_RGBA_color.B := BLUE(selected_tcolor_color);
}
      inverted_RGBA_color.A := $FF; // not transparent
      inverted_RGBA_color.R := Byte(256 - selected_RGBA_color.R);
      inverted_RGBA_color.G := Byte(256 - selected_RGBA_color.G);
      inverted_RGBA_color.B := Byte(256 - inverted_RGBA_color.B);


      //Redraw ColorPick_Current_jPanel in touched color
      ColorPick_Current_jPanel.CustomColor := ARGBtoCustomColor(selected_RGBA_color);
      ColorPick_Current_jPanel.BackgroundColor := colbrCustom;

      //Debug out touched color like #DF3456
      //ShowMessage('#' + IntToHex(Red(selected_tcolor_color), 2) +
      //  IntToHex(Green(selected_tcolor_color), 2) + IntToHex(Blue(selected_tcolor_color), 2));
      //jTextView_ColorPick.Text := '#' + IntToHex(Red(selected_tcolor_color), 2) + IntToHex(Green(selected_tcolor_color), 2) + IntToHex(Blue(selected_tcolor_color), 2);


      CircleCanvas.CustomColor := ARGBtoCustomColor(selected_RGBA_color);
      CircleCanvas.PaintColor := colbrCustom; // colbrWhite;
      CircleCanvas.PaintStyle := psFill;
      CircleCanvas.PaintStrokeWidth := 0;
      CircleCanvas.DrawCircle(circle_image_width div 2, circle_image_height div 2, circle_image_width div 2);

      CircleImage.SetImageBitmap(CircleCanvas.GetBitmap());

    end;


   ColorPickCanvas.DrawBitmap(jBitmap_ColorPick.GetImage(), 0, 0, color_picker_width, color_picker_height);
   ColorPickCanvas.PaintStyle := psStroke; // psFill psFillAndStroke;
   ColorPickCanvas.CustomColor := ARGBtoCustomColor(inverted_RGBA_color);
   ColorPickCanvas.PaintColor := colbrCustom;
   ColorPickCanvas.PaintStrokeWidth := 3;
   ColorPickCanvas.DrawCircle(touched_pixel.X, touched_pixel.Y, 10);
   ColorPick_jImageView.SetImageBitmap(ColorPickCanvas.GetBitmap());



end;

procedure TAndroidModule1.AndroidModule1Create(Sender: TObject);
begin


  app_store := GOOGLE_STORE;
  //app_store := SAMSUNG_STORE;
  //app_store := HUAWEI_STORE;
  //app_store := AMAZON_STORE;




//  init_images := false;
  init_images := true;
  inverted_RGBA_color.A := $FF; // not transparent
  inverted_RGBA_color.R := Byte(0);
  inverted_RGBA_color.G := Byte(0);
  inverted_RGBA_color.B := Byte(0);

  data_has_changed := true;


//  j_drawing_view_color_pick_width_default := 128;


  DelayForStimulusShowupStartEdit.Text := '';
  DelayForStimulusShowupEndEdit.Text := '';
  NumberOfMeasurementsEdit.Text := '';
  ClipboadEditText.Text := '';


  jPanel1.BackgroundColor := colbrBlack;

  InstructionsLabel.FontColor := colbrWhite;
  InstructionsLabel.FontSize := 24;

  instructions_label_visible := true;
  InstructionsLabel.Visible := instructions_label_visible;


  LeftButtonRoundImage.Visible := true;
  LeftButtonRoundImage.BringToFront();
  RightButtonRoundImage.Visible := true;
  RightButtonRoundImage.BringToFront();
  CircleImage.Visible := false;
  CircleImage.BringToFront();

//  FixationPointImage.Visible := fixation_point_image_visible; //does not work
  FixationPointImage.BringToFront();



  ClearDataTableButton.Visible := false;
  CopyDataToClipboardButton.Visible := false;
  DataStringGridWebView.Visible := false;

  SaveSettingsButton.Visible := false;
  ResetSettingsButton.Visible := false;
  RandomDelayTimeTextView.Visible := false;
  fromTextView.Visible := false;
  DelayForStimulusShowupStartEdit.Visible := false;
  msTextView1.Visible := false;
  DelayForStimulusShowupEndEdit.Visible := false;
  msTextView2.Visible := false;
  toTextView.Visible := false;
  NumberOfMeasurementsTextView.Visible := false;
  NumberOfMeasurementsEdit.Visible := false;
  AutoViewDataTableCheckBox.Visible := false;
  ShowInstructionsCheckBox.Visible := false;
  ShowFixationPointCheckBox.Visible := false;
  StimulusColorLabel.Visible := false;
  ColorPick_Current_jPanel.Visible := false;

  MoreAppsButton.Visible := false;
  RateAppButton.Visible := false;
  AboutWebView.Visible := false;


  about_html_stringlist := TStringList.Create();
  data_string_grid_html_stringlist := TStringList.Create();




  number_of_measurements_default := 30;
  delay_for_stimulus_showup_start_default := 1000;
  delay_for_stimulus_showup_end_default := 10000;







    first_button_clicked := false;
    second_button_clicked := false;
    stimulus_shown := false;





    step_data_point := 1;


    {$IFDEF ANDROID}
    InstructionsLabel.Text := 'Press left button.' + LineEnding + 'Keep left button pressed until circle shows up.' + LineEnding + 'Then release left button and press right button as quickly as you can.';
    {$ELSE}
    InstructionsLabel.Text := 'Press left mouse button.' + LineEnding + 'Keep left mouse button pressed' + LineEnding + 'until circle shows up.' + LineEnding + 'Then release left mouse button and press right' + LineEnding + 'mouse button as quickly as you can.';
    {$ENDIF}




end;

procedure TAndroidModule1.AndroidModule1Close(Sender: TObject);
begin

  SaveSettings();

end;

procedure TAndroidModule1.SaveSettings();
begin

//  ShowMessage('Module Close');

//exit();

  number_of_measurements := StrToIntDef(NumberOfMeasurementsEdit.Text, number_of_measurements_default);
  delay_for_stimulus_showup_start := StrToIntDef(DelayForStimulusShowupStartEdit.Text, delay_for_stimulus_showup_start_default);
  delay_for_stimulus_showup_end := StrToIntDef(DelayForStimulusShowupEndEdit.Text, delay_for_stimulus_showup_end_default);


      if((number_of_measurements < 0) or (number_of_measurements > 10000)) then // protection from crash
      begin
      number_of_measurements := number_of_measurements_default;
      end;

      ini_int_result := jPreferences1.GetIntData('number_of_measurements', 30);
      if(number_of_measurements <> ini_int_result) then
      begin

      jPreferences1.SetIntData('number_of_measurements', number_of_measurements);
      end;



      if((delay_for_stimulus_showup_start < 0) or (delay_for_stimulus_showup_start > 100000)) then // protection from crash
      begin
      delay_for_stimulus_showup_start := delay_for_stimulus_showup_start_default;
      end;

      ini_int_result := jPreferences1.GetIntData('delay_for_stimulus_showup_start', 1000);
      if(delay_for_stimulus_showup_start <> ini_int_result) then
      begin

      jPreferences1.SetIntData('delay_for_stimulus_showup_start', delay_for_stimulus_showup_start);
      end;


      if((delay_for_stimulus_showup_end < 0) or (delay_for_stimulus_showup_end > 1000000)) then // protection from crash
      begin
      delay_for_stimulus_showup_end := delay_for_stimulus_showup_end_default;
      end;


      ini_int_result := jPreferences1.GetIntData('delay_for_stimulus_showup_end', 10000);
      if((delay_for_stimulus_showup_end) <> ini_int_result) then
      begin
      jPreferences1.SetIntData('delay_for_stimulus_showup_end', delay_for_stimulus_showup_end);
      end;



      ini_bool_result := jPreferences1.GetBoolData('show_instructions', true);
      if(ShowInstructionsCheckBox.Checked <> ini_bool_result) then
      begin

      jPreferences1.SetBoolData('show_instructions', ShowInstructionsCheckBox.Checked);
      end;


      ini_bool_result := jPreferences1.GetBoolData('show_fixation_point', true);
      if(ShowFixationPointCheckBox.Checked <> ini_bool_result) then
      begin

      jPreferences1.SetBoolData('show_fixation_point', ShowFixationPointCheckBox.Checked);
      end;


      ini_bool_result := jPreferences1.GetBoolData('auto_view_data_table', true);
      if(AutoViewDataTableCheckBox.Checked <> ini_bool_result) then
      begin

      jPreferences1.SetBoolData('auto_view_data_table', AutoViewDataTableCheckBox.Checked);
      end;



      ini_string_result := jPreferences1.GetStringData('stimulus_color', '$FFFFFF');

      selected_tcolor_color_string := ColorToString(selected_tcolor_color);
      if(CompareStr(selected_tcolor_color_string, ini_string_result) <> 0) then
      begin

      jPreferences1.SetStringData('stimulus_color', selected_tcolor_color_string);

      end;


{
      ini_int_result := jPreferences1.GetIntData('color_pick_width', j_drawing_view_color_pick_width_default);
      if((j_drawing_view_color_pick_width) <> ini_int_result) then
      begin
      jPreferences1.SetIntData('color_pick_width', j_drawing_view_color_pick_width);
      end;
}




end;



end.
